Package com.io7m.cedarbridge.runtime.api

# Record Class CBMap<K extends CBSerializableType,V extends CBSerializableType>

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.runtime.api.CBMap<K,V>

Type Parameters:
  `K` - The type of keys
  `V` - The type of values
Record Components:
  `values` - The values

All Implemented Interfaces:
  `CBSerializableType`, `Formattable`

public record CBMap<K extends CBSerializableType,V extends CBSerializableType>(Map<K extends CBSerializableType,V extends CBSerializableType> values) extends Record implements Formattable, CBSerializableType
The type of maps.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBMap(Map<K,V> values)`
  The type of maps.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <K extends CBSerializableType, V extends CBSerializableType>
  CBMap<K,V>`
  `deserialize(CBSerializationContextType context, CBDeserializeType<K> fk, CBDeserializeType<V> fv)`
  Deserialize the given value.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `void`
  `formatTo(Formatter formatter, int flags, int width, int precision)`
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `static <K extends CBSerializableType, V extends CBSerializableType>
  void`
  `serialize(CBSerializationContextType context, CBMap<K,V> x, CBSerializeType<K> fk, CBSerializeType<V> fv)`
  Serialize the given value.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Map<K,V>`
  `values()`
  Returns the value of the `values` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBMap

    public CBMap(Map<K,V> values)
    The type of maps.
    Parameters:
      `values` - The values

- ## Method Details

  - ### formatTo

    public void formatTo(Formatter formatter, int flags, int width, int precision)
    Specified by:
      `formatTo` in interface `Formattable`

  - ### serialize

    public static <K extends CBSerializableType, V extends CBSerializableType> void serialize(CBSerializationContextType context, CBMap<K,V> x, CBSerializeType<K> fk, CBSerializeType<V> fv) throws IOException
    Serialize the given value.
    Type Parameters:
      `K` - The type of keys
      `V` - The type of values
    Parameters:
      `context` - The serialization context
      `x` - The value
      `fk` - A serializer for `K`
      `fv` - A serializer of `V`
    Throws:
      `IOException` - On errors

  - ### deserialize

    public static <K extends CBSerializableType, V extends CBSerializableType> CBMap<K,V> deserialize(CBSerializationContextType context, CBDeserializeType<K> fk, CBDeserializeType<V> fv) throws IOException
    Deserialize the given value.
    Parameters:
      `context` - The serialization context
    Returns:
      The deserialized value
    Throws:
      `IOException` - On errors

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### values

    public Map<K,V> values()
    Returns the value of the `values` record component.
    Returns:
      the value of the `values` record component